# Class VulkanSubmitInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanSubmitInfo

All Implemented Interfaces:
  `VulkanSubmitInfoType`

public final class VulkanSubmitInfo extends Object implements VulkanSubmitInfoType
The type of Vulkan submission information.

See Also:
  - "VkSubmitInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanSubmitInfo.Builder`
  Builds instances of type `VulkanSubmitInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanSubmitInfo.Builder`
  `builder()`
  Creates a builder for `VulkanSubmitInfo`.
  `List<VulkanCommandBufferType>`
  `commandBuffers()`
  `static VulkanSubmitInfo`
  `copyOf(VulkanSubmitInfoType instance)`
  Creates an immutable copy of a `VulkanSubmitInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanSubmitInfo` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `waitSemaphores`, `waitStageMasks`, `commandBuffers`, `signalSemaphores`.
  `static VulkanSubmitInfo`
  `of(Iterable<? extends VulkanSemaphoreType> waitSemaphores, Iterable<? extends VulkanPipelineStageFlag> waitStageMasks, Iterable<? extends VulkanCommandBufferType> commandBuffers, Iterable<? extends VulkanSemaphoreType> signalSemaphores)`
  Construct a new immutable `VulkanSubmitInfo` instance.
  `static VulkanSubmitInfo`
  `of(List<VulkanSemaphoreType> waitSemaphores, List<VulkanPipelineStageFlag> waitStageMasks, List<VulkanCommandBufferType> commandBuffers, List<VulkanSemaphoreType> signalSemaphores)`
  Construct a new immutable `VulkanSubmitInfo` instance.
  `List<VulkanSemaphoreType>`
  `signalSemaphores()`
  `String`
  `toString()`
  Prints the immutable value `VulkanSubmitInfo` with attribute values.
  `List<VulkanSemaphoreType>`
  `waitSemaphores()`
  `List<VulkanPipelineStageFlag>`
  `waitStageMasks()`
  `final VulkanSubmitInfo`
  `withCommandBuffers(VulkanCommandBufferType... elements)`
  Copy the current immutable object with elements that replace the content of `commandBuffers`.
  `final VulkanSubmitInfo`
  `withCommandBuffers(Iterable<? extends VulkanCommandBufferType> elements)`
  Copy the current immutable object with elements that replace the content of `commandBuffers`.
  `final VulkanSubmitInfo`
  `withSignalSemaphores(VulkanSemaphoreType... elements)`
  Copy the current immutable object with elements that replace the content of `signalSemaphores`.
  `final VulkanSubmitInfo`
  `withSignalSemaphores(Iterable<? extends VulkanSemaphoreType> elements)`
  Copy the current immutable object with elements that replace the content of `signalSemaphores`.
  `final VulkanSubmitInfo`
  `withWaitSemaphores(VulkanSemaphoreType... elements)`
  Copy the current immutable object with elements that replace the content of `waitSemaphores`.
  `final VulkanSubmitInfo`
  `withWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)`
  Copy the current immutable object with elements that replace the content of `waitSemaphores`.
  `final VulkanSubmitInfo`
  `withWaitStageMasks(VulkanPipelineStageFlag... elements)`
  Copy the current immutable object with elements that replace the content of `waitStageMasks`.
  `final VulkanSubmitInfo`
  `withWaitStageMasks(Iterable<? extends VulkanPipelineStageFlag> elements)`
  Copy the current immutable object with elements that replace the content of `waitStageMasks`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jcoronado.api.VulkanSubmitInfoType

  `checkPreconditions`

- ## Method Details

  - ### waitSemaphores

    public List<VulkanSemaphoreType> waitSemaphores()
    Specified by:
      `waitSemaphores` in interface `VulkanSubmitInfoType`
    Returns:
      A list of semaphores upon which to wait before the command buffers for this batch begin execution. If semaphores to wait on are provided, they define a semaphore wait operation.

  - ### waitStageMasks

    public List<VulkanPipelineStageFlag> waitStageMasks()
    Specified by:
      `waitStageMasks` in interface `VulkanSubmitInfoType`
    Returns:
      A list of pipeline stages at which each corresponding semaphore wait will occur.

  - ### commandBuffers

    public List<VulkanCommandBufferType> commandBuffers()
    Specified by:
      `commandBuffers` in interface `VulkanSubmitInfoType`
    Returns:
      A list of command buffers to execute in the batch.

  - ### signalSemaphores

    public List<VulkanSemaphoreType> signalSemaphores()
    Specified by:
      `signalSemaphores` in interface `VulkanSubmitInfoType`
    Returns:
      A list of semaphores which will be signaled when the command buffers for this batch have completed execution. If semaphores to be signaled are provided, they define a semaphore signal operation.

  - ### withWaitSemaphores

    public final VulkanSubmitInfo withWaitSemaphores(VulkanSemaphoreType... elements)
    Copy the current immutable object with elements that replace the content of `waitSemaphores`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withWaitSemaphores

    public final VulkanSubmitInfo withWaitSemaphores(Iterable<? extends VulkanSemaphoreType> elements)
    Copy the current immutable object with elements that replace the content of `waitSemaphores`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of waitSemaphores elements to set
    Returns:
      A modified copy of `this` object

  - ### withWaitStageMasks

    public final VulkanSubmitInfo withWaitStageMasks(VulkanPipelineStageFlag... elements)
    Copy the current immutable object with elements that replace the content of `waitStageMasks`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withWaitStageMasks

    public final VulkanSubmitInfo withWaitStageMasks(Iterable<? extends VulkanPipelineStageFlag> elements)
    Copy the current immutable object with elements that replace the content of `waitStageMasks`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of waitStageMasks elements to set
    Returns:
      A modified copy of `this` object

  - ### withCommandBuffers

    public final VulkanSubmitInfo withCommandBuffers(VulkanCommandBufferType... elements)
    Copy the current immutable object with elements that replace the content of `commandBuffers`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withCommandBuffers

    public final VulkanSubmitInfo withCommandBuffers(Iterable<? extends VulkanCommandBufferType> elements)
    Copy the current immutable object with elements that replace the content of `commandBuffers`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of commandBuffers elements to set
    Returns:
      A modified copy of `this` object

  - ### withSignalSemaphores

    public final VulkanSubmitInfo withSignalSemaphores(VulkanSemaphoreType... elements)
    Copy the current immutable object with elements that replace the content of `signalSemaphores`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withSignalSemaphores

    public final VulkanSubmitInfo withSignalSemaphores(Iterable<? extends VulkanSemaphoreType> elements)
    Copy the current immutable object with elements that replace the content of `signalSemaphores`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of signalSemaphores elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanSubmitInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `waitSemaphores`, `waitStageMasks`, `commandBuffers`, `signalSemaphores`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanSubmitInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanSubmitInfo of(List<VulkanSemaphoreType> waitSemaphores, List<VulkanPipelineStageFlag> waitStageMasks, List<VulkanCommandBufferType> commandBuffers, List<VulkanSemaphoreType> signalSemaphores)
    Construct a new immutable `VulkanSubmitInfo` instance.
    Parameters:
      `waitSemaphores` - The value for the `waitSemaphores` attribute
      `waitStageMasks` - The value for the `waitStageMasks` attribute
      `commandBuffers` - The value for the `commandBuffers` attribute
      `signalSemaphores` - The value for the `signalSemaphores` attribute
    Returns:
      An immutable VulkanSubmitInfo instance

  - ### of

    public static VulkanSubmitInfo of(Iterable<? extends VulkanSemaphoreType> waitSemaphores, Iterable<? extends VulkanPipelineStageFlag> waitStageMasks, Iterable<? extends VulkanCommandBufferType> commandBuffers, Iterable<? extends VulkanSemaphoreType> signalSemaphores)
    Construct a new immutable `VulkanSubmitInfo` instance.
    Parameters:
      `waitSemaphores` - The value for the `waitSemaphores` attribute
      `waitStageMasks` - The value for the `waitStageMasks` attribute
      `commandBuffers` - The value for the `commandBuffers` attribute
      `signalSemaphores` - The value for the `signalSemaphores` attribute
    Returns:
      An immutable VulkanSubmitInfo instance

  - ### copyOf

    public static VulkanSubmitInfo copyOf(VulkanSubmitInfoType instance)
    Creates an immutable copy of a `VulkanSubmitInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanSubmitInfo instance

  - ### builder

    public static VulkanSubmitInfo.Builder builder()
    Creates a builder for `VulkanSubmitInfo`.

         VulkanSubmitInfo.builder()
            .addWaitSemaphores|addAllWaitSemaphores(com.io7m.jcoronado.api.VulkanSemaphoreType) // waitSemaphores elements
            .addWaitStageMasks|addAllWaitStageMasks(com.io7m.jcoronado.api.VulkanPipelineStageFlag) // waitStageMasks elements
            .addCommandBuffers|addAllCommandBuffers(com.io7m.jcoronado.api.VulkanCommandBufferType) // commandBuffers elements
            .addSignalSemaphores|addAllSignalSemaphores(com.io7m.jcoronado.api.VulkanSemaphoreType) // signalSemaphores elements
            .build();

    Returns:
      A new VulkanSubmitInfo builder